#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Mentat::Message::Formater::TextTemplate module/class tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
#
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 5;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Mentat::Message::Formater::TextTemplate';

        use_ok('Tester');
        use_ok($TESTED_CLASS);
        use_ok('Mentat::Message::Factory');
    }

# Debug output explicit ON switch
Tester::DEBUG_ON();

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
diag("$TESTED_CLASS version: " . $Mentat::Message::Formater::TextTemplate::VERSION) if Tester::D(2);
diag("Mentat::Message::Factory version: " . $Mentat::Message::Factory::VERSION) if Tester::D(2);

my $helper = Mentat::Message::Formater::Helper->service();

# Now attempt to create a class instance and check it
my $instance1 = $TESTED_CLASS->new('../../formater-templates/email', $helper);
isa_ok($instance1, $TESTED_CLASS);

## View the created instance
diag("Instance dump 01: " . Dumper($instance1)) if Tester::D(2);

# Now attempt to create a class instance and check it
my $instance2 = $TESTED_CLASS->new('../../formater-templates/csv', $helper);
isa_ok($instance2, $TESTED_CLASS);

## View the created instance
diag("Instance dump 02: " . Dumper($instance1)) if Tester::D(2);

my $message01 = Mentat::Message::Factory->from_file('./data/alert01.idea');
my $message02 = Mentat::Message::Factory->from_file('./data/alert02.idea');
my $message03 = Mentat::Message::Factory->from_file('./data/alert03.idea');
my $message04 = Mentat::Message::Factory->from_file('./data/alert04.idea');
my $message05 = Mentat::Message::Factory->from_file('./data/alert05.idea');
my $message06 = Mentat::Message::Factory->from_file('./data/alert06.idea');
my $message07 = Mentat::Message::Factory->from_file('./data/alert07.idea');
my $message08 = Mentat::Message::Factory->from_file('./data/alert08.idea');
my $message09 = Mentat::Message::Factory->from_file('./data/alert09.idea');
my $message10 = Mentat::Message::Factory->from_file('./data/alert10.idea');

my $messages = [$message01, $message02, $message03, $message04, $message05, $message06, $message07, $message08, $message09, $message10];

#my $messages = [$message12];
#print STDERR Dumper($message12);

my $context = {
    'cnt_all'     => 10,
    'cnt_ips'     => 1,
    'cnt_flt_blk' => 0,

    'frv'     => 'Filter',
    'abuse'   => 'abuse@domain',
    'type'    => 'summary',
    'th'      => time,
    'tl'      => (time - 7200),
};

print STDERR Dumper($instance1->format_report('ReportID', $messages, $context));
print STDERR Dumper($instance2->format_report('ReportID', $messages, $context));

#$context = {
    #'cnt_ips_all'    => 1,
    #'cnt_ips_unique' => 1,
    #'cnt_flt'        => 0,
    #'cnt_blk'        => 0,

    #'frv'     => 'Filter',
    #'abuse'   => 'abuse@domain',
    #'th'      => time,
    #'tl'      => (time - 7200),
#};

#foreach my $ip (sort keys(%$group))
#{
    #print STDERR Dumper($instance1->format_extraip('ReportID', $ip, $group->{$ip}, $context)) if Tester::D();
    #print STDERR Dumper($instance2->format_extraip('ReportID', $ip, $group->{$ip}, $context)) if Tester::D();
#}
