#!/usr/bin/perl -T

use strict;
use warnings;

#*******************************************************************************
# Mentat::Stats::Data module/class tests
#
# Author:   Jan Mach, jan.mach@cesnet.cz
# Version:  0.1
# Purpose:
#
#*******************************************************************************

use Data::Dumper;
#use Smart::Comments;

use Test::More tests => 5;

# First test if the module correctly compiles
BEGIN {
        use vars qw($TESTED_CLASS);
        $TESTED_CLASS = 'Mentat::Stats::Data';

        use_ok('Tester');
        use_ok('Mentat::Message::Factory');
        use_ok($TESTED_CLASS);

        $ENV{PATH} = '/bin:/usr/bin';
    }

# Debug output explicit ON switch
#Tester::DEBUG_ON();
#Tester::DEBUG_ON(10);

# Debug output explicit OFF switch
#Tester::DEBUG_OFF();

# User should know, which version is beeing tested (just for sure)
### $Mentat::Stats::Data::VERSION

### Attempting to create Mentat::Stats::Data instance...
my $instance = $TESTED_CLASS->new(charts_dir => './data');
isa_ok($instance, $TESTED_CLASS);

### Viewing the created instance: $instance
diag("Instance dump 01: " . Dumper($instance)) if Tester::D(2);

my $msg = Mentat::Message::Factory->from_file('./data/msg_val.idea');
isa_ok($msg, 'Mentat::Message::IDEA');

diag(Dumper($instance->evaluate_alerts([$msg])));
